/* 3-4-95 Jens David <dg1kjd@dg1kjd.ampr.org / dg1kjd@sugarland.ampr.org> */

#include "global.h"
#include "mbuf.h"
#include "iface.h"
#include "timer.h"
#include "internet.h"
#include "ip.h"
#include "tcp.h"
#include "netuser.h"
#include "icmp.h"
#include "rip.h"
#include "trace.h"
#include "pktdrvr.h"
#include "bootp.h"
#include "config.h"

/* well, maybe I'm exaggerating a little bit :-) */

int
ip_chk(
struct iface *i_iface,  /* Input interface */
struct mbuf *bp,        /* Input packet */
int rxbroadcast)        /* True if packet had link broadcast address */
{
	uint16 ip_len;                  /* IP header length */

	if(len_p(bp) < IPLEN) { return 0; }
	
	/* Sneak a peek at the IP header's IHL field to find its length */

	ip_len = (bp->data[0] & 0xf) << 2;
	if(ip_len < IPLEN){
		/* The IP header length field is too small */
		return 0;
	}
	if(cksum(NULLHEADER,bp,ip_len) != 0){
		/* Bad IP header checksum; discard */
		return 0;
	}
	return 1;
}
