/* @(#) $Header: login.h,v 1.9 93/05/17 13:45:07 deyke Exp $ */

#ifndef _LOGIN_H
#define _LOGIN_H

#ifndef _TIMER_H
#include "timer.h"
#endif

/* login server control block */
struct login_cb {
  int type;			/* type of connection */
#define LOGINTYPE_AX25 		1
#define LOGINTYPE_NETROM	2
  int pty;                      /* pty file descriptor */
  char ptyname[80];             /* pty device file name */
  pid_t pid;                    /* process id of login process */
  char inpbuf[512];             /* pty read buffer */
  char *inpptr;                 /* pty read buffer pointer */
  int inpcnt;                   /* pty read buffer count */
  struct mbuf *sndq;            /* pty send queue */
  int lastchr;                  /* last chr fetched from send queue */
  int linelen;                  /* counter for automatic line break */
  char outbuf[256];             /* pty write buffer */
  char *outptr;                 /* pty write buffer pointer */
  int outcnt;                   /* pty write buffer count */
  void (*readfnc)(void *fncarg);
				/* func to call if pty is readable */
  void (*closefnc)(void *fncarg);
				/* func to call if pty gets closed */
  void *fncarg;                 /* argument for readfnc and closefnc */
  FILE *logfp;                  /* log file pointer */
  int loglastchr;               /* last char written to logfile */
  struct timer rectimer[1];	/* reconnect timeout */
  int recon_inprog;		/* recon in progress? */
  int wantclose;		/* close of session intended? */
};

extern int login_recon;
extern long Rectimeout;

/* In login.c: */
void fixutmpfile(void);
struct passwd *getpasswdentry(const char *name, int create, struct login_cb *tp);
struct login_cb *login_open(const char *user, const char *protocol,
	void (*read_upcall)(void *arg),
	void (*close_upcall)(void *arg),
	void *upcall_arg);
void login_close(struct login_cb *tp);
struct mbuf *login_read(struct login_cb *tp, int cnt);
void login_write(struct login_cb *tp, struct mbuf *bp);

#endif  /* _LOGIN_H */
